"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WhereHasCondition = void 0;
var renderable_1 = require("../../support/renderable");
var WhereHasCondition = /** @class */ (function () {
    function WhereHasCondition(relation, args) {
        this.kind = 'whereHas';
        this.relation = relation;
        this.args = args;
        this.subquery = renderable_1.isRenderable(this.args) ? this.args.render() : null;
    }
    WhereHasCondition.prototype.render = function () {
        return {
            kind: this.kind,
            args: {
                relation: this.relation,
                subquery: this.subquery,
            },
        };
    };
    return WhereHasCondition;
}());
exports.WhereHasCondition = WhereHasCondition;
