"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryBuilder = void 0;
var queries = require("./queries/index");
var QueryBuilder = /** @class */ (function () {
    function QueryBuilder() {
    }
    QueryBuilder.create = function (type, key, params) {
        return new queries.CreateQuery(type, key, params);
    };
    QueryBuilder.custom = function (type, key, params) {
        return new queries.CustomQuery(type, key, params);
    };
    QueryBuilder.delete = function (type, key, id) {
        return new queries.DeleteQuery(type, key, id);
    };
    QueryBuilder.fetch = function (type, key) {
        return new queries.FetchQuery(type, key);
    };
    QueryBuilder.find = function (type, key, id) {
        return new queries.FindQuery(type, key, id);
    };
    QueryBuilder.update = function (type, key, id, params) {
        return new queries.UpdateQuery(type, key, id, params);
    };
    return QueryBuilder;
}());
exports.QueryBuilder = QueryBuilder;
