import { BackendResult } from './backend-result';
import { QueryTraceInterface } from './support';
import { QueryDataInterface, QueryDataRowInterface } from './support/data-interfaces';
import { QueryErrorsInterface, QueryErrorInterface } from './support/error-interfaces';
export declare class QueryResult {
    private result;
    hasData(): boolean;
    hasErrors(): boolean;
    hasTrace(): boolean;
    hasWarnings(): boolean;
    getResult(): BackendResult;
    getErrors(): QueryErrorsInterface;
    getTraces(): QueryTraceInterface;
    setResult(result: BackendResult): void;
    getData(): QueryDataInterface;
    getDataRow(key: string): QueryDataRowInterface;
    getContent(key: string): any;
    getError(key: string): QueryErrorInterface;
    getGlobalErrors(): any;
    getTrace(key: string): Array<any>;
    getWarning(key: string): Array<string>;
    hasContent(key: string): boolean;
    hasErrorKey(key: string): boolean;
    hasDataKey(key: string): boolean;
    hasWarningKey(key: string): boolean;
    hasTraceKey(key: string): boolean;
}
