"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryResult = void 0;
var QueryResult = /** @class */ (function () {
    function QueryResult() {
    }
    QueryResult.prototype.hasData = function () {
        return Object.keys(this.result.data).length > 0;
    };
    QueryResult.prototype.hasErrors = function () {
        return Object.keys(this.result.errors).length > 0;
    };
    QueryResult.prototype.hasTrace = function () {
        return Object.keys(this.result.trace).length > 0;
    };
    QueryResult.prototype.hasWarnings = function () {
        return Object.keys(this.result.warnings).length > 0;
    };
    QueryResult.prototype.getResult = function () {
        return this.result;
    };
    QueryResult.prototype.getErrors = function () {
        return this.result.errors;
    };
    QueryResult.prototype.getTraces = function () {
        return this.result.trace;
    };
    QueryResult.prototype.setResult = function (result) {
        this.result = result;
    };
    QueryResult.prototype.getData = function () {
        return this.result.data;
    };
    QueryResult.prototype.getDataRow = function (key) {
        return this.result.data[key];
    };
    QueryResult.prototype.getContent = function (key) {
        return this.result.data[key].content;
    };
    QueryResult.prototype.getError = function (key) {
        return this.result.errors[key];
    };
    QueryResult.prototype.getGlobalErrors = function () {
        return this.result.errors.__global;
    };
    QueryResult.prototype.getTrace = function (key) {
        return this.result.trace[key];
    };
    QueryResult.prototype.getWarning = function (key) {
        return this.result.warnings[key];
    };
    QueryResult.prototype.hasContent = function (key) {
        return this.hasDataKey(key) && typeof this.result.data[key].content !== 'undefined';
    };
    QueryResult.prototype.hasErrorKey = function (key) {
        return this.hasErrors() && typeof this.result.errors[key] !== 'undefined';
    };
    QueryResult.prototype.hasDataKey = function (key) {
        return this.hasData() && typeof this.result.data[key] !== 'undefined';
    };
    QueryResult.prototype.hasWarningKey = function (key) {
        return this.hasWarnings() && typeof this.result.warnings[key] !== 'undefined';
    };
    QueryResult.prototype.hasTraceKey = function (key) {
        return this.hasTrace() && typeof this.result.trace[key] !== 'undefined';
    };
    return QueryResult;
}());
exports.QueryResult = QueryResult;
