import { Query } from './queries/query';
import { QueryResult } from './query-result';
/**
 * Promise-based query runner example
 */
export declare class QueryRunner {
    private result;
    private queries;
    private http;
    private apiURL;
    private queryMode;
    /**
     *
     * @param http - Http Client instance, axios for ex.
     * @param apiURL - Backend URL endpoint for your queries
     */
    constructor(http: any, apiURL: string);
    private runQueries;
    /**
     * Runs all queries in a whole transaction
     */
    runTransaction(): Promise<QueryResult>;
    /**
     * Runs all queries individually
     */
    runMultiple(): Promise<QueryResult>;
    addQuery(query: Query): void;
    setQueries(queries: Query[]): void;
    getQueries(): Query[];
    setQueryMode(mode: string): void;
    getQueryMode(): string;
    getApiURL(): string;
    setApiURL(apiURL: string): void;
    getHttp(): any;
    setHttp(http: any): void;
}
