"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryRunner = void 0;
var query_result_1 = require("./query-result");
/**
 * Promise-based query runner example
 */
var QueryRunner = /** @class */ (function () {
    /**
     *
     * @param http - Http Client instance, axios for ex.
     * @param apiURL - Backend URL endpoint for your queries
     */
    function QueryRunner(http, apiURL) {
        this.result = new query_result_1.QueryResult();
        this.setQueries([]);
        this.setHttp(http);
        this.setApiURL(apiURL);
    }
    QueryRunner.prototype.runQueries = function () {
        return __awaiter(this, void 0, void 0, function () {
            var queryData;
            return __generator(this, function (_a) {
                queryData = [];
                this.queries.forEach(function (query) {
                    queryData.push(query.render());
                });
                return [2 /*return*/, this.http.post("" + this.apiURL, {
                        query_data: queryData,
                        query_mode: this.queryMode,
                    }).then(function (response) { return response.data; })];
            });
        });
    };
    /**
     * Runs all queries in a whole transaction
     */
    QueryRunner.prototype.runTransaction = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                this.setQueryMode('transaction');
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.runQueries().then(function (backendResult) {
                            _this.result.setResult(backendResult);
                            if (_this.result.hasErrors()) {
                                reject(_this.result);
                            }
                            else {
                                resolve(_this.result);
                            }
                        })
                            .catch(function (error) {
                            reject(error);
                        });
                    })];
            });
        });
    };
    /**
     * Runs all queries individually
     */
    QueryRunner.prototype.runMultiple = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                this.setQueryMode('multiple');
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.runQueries().then(function (backendResult) {
                            _this.result.setResult(backendResult);
                            resolve(_this.result);
                        })
                            .catch(function (error) {
                            reject(error);
                        });
                    })];
            });
        });
    };
    QueryRunner.prototype.addQuery = function (query) {
        this.queries.push(query);
    };
    QueryRunner.prototype.setQueries = function (queries) {
        this.queries = queries;
    };
    QueryRunner.prototype.getQueries = function () {
        return this.queries;
    };
    QueryRunner.prototype.setQueryMode = function (mode) {
        this.queryMode = mode;
    };
    QueryRunner.prototype.getQueryMode = function () {
        return this.queryMode;
    };
    QueryRunner.prototype.getApiURL = function () {
        return this.apiURL;
    };
    QueryRunner.prototype.setApiURL = function (apiURL) {
        this.apiURL = apiURL;
    };
    QueryRunner.prototype.getHttp = function () {
        return this.http;
    };
    QueryRunner.prototype.setHttp = function (http) {
        this.http = http;
    };
    return QueryRunner;
}());
exports.QueryRunner = QueryRunner;
